#include <bits/stdc++.h>
#include <experimental/random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
constexpr ll INF = 1e18;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;

ll n;
vector<ll> h, k;

bool chk(const ll i) {
    if (i == 0 && (h[i] <= h[i+1] || h[i] >= h[i+1])) return true;
    if (i == n-1 && (h[i] <= h[i-1] || h[i] >= h[i-1])) return true;
    if ((h[i] <= h[i+1] && h[i-1] <= h[i]) || (h[i] >= h[i+1] && h[i-1] >= h[i])) return true;
    return false;
}

ll ind = -1;

void group4() {
    if (ind == -1) {
        cout << 0;
        exit(0);
    }
    vector<ll> pref(n+1);
    pref[0] = 0;
    for (ll i = 1; i <= n; i++) {
        pref[i] = pref[i-1] + h[i-1];
    }
    set<pair<ll,ll>> a;
    for (int i = 0; i < n; ++i) {
        a.insert({i, i});
    }
    for (int i = 0; i < n-1; ++i) {
        auto it = a.begin();
        for (int j = 0; j < k[i]; ++j) {
            ++it;
        }
        pair<ll,ll> x = *it;
        pair<ll,ll> y = *++it;
        ll l, r;
        if (ind >= x.first && ind <= y.second) {
            if (h[x.first] > h[y.second]) {
                l = x.first, r = ind;
                while (l < r - 1) {
                    ll m = (r + l) / 2;
                    if (h[m] < h[y.second]) r= m;
                    else l = m;
                }
            } else {
                l = ind, r = y.second;
                while (l < r - 1) {
                    ll m = (r + l) / 2;
                    if (h[m] > h[x.first]) r= m;
                    else l = m;
                }
            }
            if (l >= ind) {
                cout << y.second*((ind+1)-l+1) - (pref[ind+1] - pref[l]) << '\n';
            } else {
                cout << x.first*((l+1)-ind+1) - (pref[l+1] - pref[ind]) << '\n';
            }
        } else {
            cout << "0\n";
        }
        a.erase(x);
        a.erase(y);
        a.insert({x.first, y.second});
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cin >> n;
    h.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    k.resize(n-1);
    int cnt = 0;
    int cnt1 = 0;
    bool ch = true;
    int sost = 0;
    for (int i = 1; i < n; ++i) {
        if (h[i] < h[i-1] && sost == 1) {
            ch = false;
            break;
        }
        if (h[i] > h[i-1] && sost == 0) {
            sost = 1;
        }
    }
    for (int i = 0; i < n-1; ++i) {
        ll x;
        cin >> x;
        x--;
        k[i] = x;
        if (x == 0) cnt++;
    }
    if (ch) group4();
    set<pair<ll,ll>> a;
    for (int i = 0; i < n; ++i) {
        a.insert({i, i});
    }
    vector<ll> mx_l = h, mx_r = h;
    for (int i = 0; i < n-1; ++i) {
        auto it = a.begin();
        for (int j = 0; j < k[i]; ++j) {
            ++it;
        }
        pair<ll,ll> x = *it;
        pair<ll,ll> y = *++it;
        for (ll j = y.first; j <= y.second; ++j) {
            mx_l[j] = max(mx_l[x.second], mx_l[j]);
        }
        for (ll j = x.first; j <= x.second; ++j) {
            mx_r[j] = max(mx_r[y.first], mx_r[j]);
        }
        ll res = 0;
        for (ll j = x.first; j <= y.second; ++j) {
            res += min(mx_l[j], mx_r[j]) - h[j];
        }
        cout << res << '\n';
        a.erase(x);
        a.erase(y);
        a.insert({x.first, y.second});
    }
    return 0;
}