#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3, unroll-loops")

using namespace std;
using ll = long long;
using ld = long double;
ll INF = 1e18;

vector<ll> tree, a;

void build(ll v, ll l, ll r) {
    if (l == r-1) {
        tree[v] = a[l];
        return;
    }
    ll m = (l + r) / 2;
    build(v*2, l, m);
    build(v*2+1, m, r);
    tree[v] = min(tree[v*2], tree[v*2+1]);
}

ll get(ll v, ll l, ll r, ll ql, ll qr) {
    if (ql <= l && r <= qr) return tree[v];
    if (ql >= r || l >= qr) return INF;
    ll m = (l + r) / 2;
    return min(get(2*v, l, m, ql, qr), get(2*v+1, m, r, ql, qr));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    ll n, k;
    cin >> n >> k;
    vector<ll> pref(n+1);
    a.resize(n);
    tree.resize(4*n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 1; i < n+1; ++i) {
        pref[i] = pref[i-1] + a[i-1];
    }
    build(1, 0, n);
    ll ans = -INF;

    for (int i = 0; i <= k-1; ++i) {
        ll mn = INF;
        mn = min(mn, get(1, 0, n, 0, i));
        mn = min(mn, get(1, 0, n, n-1-(k-2-i), n));
        ans = max(ans, pref[n - (k-1-i)] - pref[i] - mn);
    }
    for (int i = 0; i < n-(k-2); ++i) {
        ll mn = INF;
        mn = min(mn, get(1, 0, n, i, i+k-1));
        ans = max(ans, max(pref[i], pref[n] - pref[i + k-1]) - mn);
    }

    cout << ans;
    return 0;
}
