#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3, unroll-loops")

using namespace std;
using ll = long long;
using ld = long double;
ll INF = 1e18;

mt19937 rnd(time(nullptr));

ll rand(ll n) {
    return rnd() % n;
}

ll rand(ll l, ll r) {
    return l + rand(r - l + 1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n), pref(n+1);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 1; i < n+1; ++i) {
        pref[i] = pref[i-1] + a[i-1];
    }

    ll ans = -INF;
    vector<ll> split(k);
    split[k-1] = n;

    for (int i = 0; i < 1e5; ++i) {
        split[k-2] = rand(k-1, n-1);
        for (int j = k-3; j >= 0; --j) {
            split[j] = rand(1+j, split[j+1]-1);
        }
        ll mx = -INF, mn = INF;
        mx = max(mx, pref[split[0]]);
        mn = min(mn, pref[split[0]]);
        for (int j = 0; j < k-1; ++j) {
            mx = max(mx, pref[split[j+1]] - pref[split[j]]);
            mn = min(mn, pref[split[j+1]] - pref[split[j]]);
        }
        ans = max(ans, mx - mn);
    }
    cout << ans;
    return 0;
}
