#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3, unroll-loops")

using namespace std;
using ll = long long;
using ld = long double;
ll INF = 1e18;

ll n, s;
vector<vector<ll>> a;

void n1() {
    vector<ll> dp(s+1, -1);
    dp[0] = 0;
    for (int i = 0; i < a[0].size(); ++i) {
        for (int j = s - a[0][i]; j >= 0; --j) {
            if (dp[j] != -1 && dp[j + a[0][i]] == -1) {
                dp[j + a[0][i]] = i;
            }
        }
    }
    if (dp[s] == -1) {
        cout << "No";
    } else {
        cout << "Yes\n";
        vector<ll> ans;
        ll j = s;
        while (j > 0) {
            ans.push_back(dp[j]+1);
            j -= a[0][dp[j]];
        }
        cout << ans.size() << '\n';
        for (int i = ans.size()-1; i >= 0; --i) {
            cout << ans[i] << ' ';
        }
    }
    exit(0);
}

void n2() {
    vector<ll> dp(s+1, -1), dp1(s+1, -1);
    dp1[0] = 0;
    dp[0] = 0;
    for (int i = 0; i < a[0].size(); ++i) {
        for (int j = s - a[0][i]; j >= 0; --j) {
            if (dp[j] != -1 && dp[j + a[0][i]] == -1) {
                dp[j + a[0][i]] = i;
            }
        }
    }
    for (int i = 0; i < a[1].size(); ++i) {
        for (int j = s - a[1][i]; j >= 0; --j) {
            if (dp1[j] != -1 && dp1[j + a[1][i]] == -1) {
                dp1[j + a[1][i]] = i;
            }
        }
    }
    for (int i = 1; i < s; ++i) {
        if (dp[i] != -1 && dp1[s-i] != -1) {
            cout << "Yes\n";
            vector<ll> ans;
            ll j = i;
            while (j > 0) {
                ans.push_back(dp[j]+1);
                j -= a[0][dp[j]];
            }
            cout << ans.size() << '\n';
            for (int l = ans.size()-1; l >= 0; --l) {
                cout << ans[l] << ' ';
            }
            cout<< '\n';
            ans.resize(0);
            j = s-i;
            while (j > 0) {
                ans.push_back(dp1[j]+1);
                j -= a[0][dp1[j]];
            }
            cout << ans.size() << '\n';
            for (int l = ans.size()-1; l >= 0; --l) {
                cout << ans[l] << ' ';
            }
            exit(0);
        }
        if (dp1[i] != -1 && dp[s-i] != -1) {
            cout << "Yes\n";
            vector<ll> ans;
            ll j = s-i;
            while (j > 0) {
                ans.push_back(dp[j]+1);
                j -= a[0][dp[j]];
            }
            cout << ans.size() << '\n';
            for (int l = ans.size()-1; l >= 0; --l) {
                cout << ans[l] << ' ';
            }
            cout<< '\n';
            ans.resize(0);
            j = i;
            while (j > 0) {
                ans.push_back(dp1[j]+1);
                j -= a[0][dp1[j]];
            }
            cout << ans.size() << '\n';
            for (int l = ans.size()-1; l >= 0; --l) {
                cout << ans[l] << ' ';
            }
            exit(0);
        }
    }
    cout << "No";
    exit(0);
}

void k1() {
    ll sum = 0;
    for (int i = 0; i < n; ++i) {
        sum += a[i][0];
    }
    if (sum != s) {
        cout << "No";
    } else {
        cout << "Yes\n";
        for (int i = 0; i < n; ++i) {
            cout << "1\n1\n";
        }
    }
    exit(0);
}

vector<ll> rec;
vector<pair<ll,ll>> ind;

void k20(ll i, ll n1) {
    if (i == n1) {
        ll sum = 0;
        for (int j = 0; j < n1; ++j) {
            if (rec[j] == 1) {
                sum += a[ind[j].first][ind[j].second];
            }
        }
        if (sum == s) {
            vector<vector<ll>> ans(n);
            for (int j = 0; j < n1; ++j) {
                if (rec[j] == 1) ans[ind[j].first].push_back(ind[j].second);
            }
            bool chk = true;
            for (int j = 0; j < n; ++j) {
                if (ans[j].size() == 0) {
                    chk = false;
                    break;
                }
            }
            if (chk) {
                cout << "Yes\n";
                for (int j = 0; j < n; ++j) {
                    cout << ans[j].size() << '\n';
                    for (int l = 0; l < ans[j].size(); ++l) {
                        cout << ans[j][l]+1 << ' ';
                    }
                    cout << '\n';
                }
                exit(0);
            }
        }
        return;
    }
    rec[i] = 1;
    k20(i+1, n1);
    rec[i] = 0;
    k20(i+1, n1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    cin >> n >> s;
    a.resize(n);
    ll mx = 1;
    ll sum = 0;
    for (int i = 0; i < n; ++i) {
        ll x;
        cin >> x;
        sum += x;
        if (x > 1) mx = x;
        for (int j = 0; j < x; ++j) {
            ll y;
            cin >> y;
            a[i].push_back(y);
        }
    }
    if (n == 2) n2();
    if (sum <= 20) {
        ind.resize(sum);
        int i1 = 0, j1 = 0;
        for (int i = 0; i < sum; ++i) {
            if (a[i1].size() > j1) {
                ind[i] = {i1, j1};
                j1++;
            } else {
                i1++;
                j1 = 0;
                ind[i] = {i1, j1};
                j1++;
            }
        }
        rec.resize(sum);
        k20(0, sum);
        cout << "No";
        return 0;
    }
    if (n == 1) n1();
    if (n == 2) n2();
    if (mx == 1) k1();
    return 0;
}